// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from novatel_gps_msgs:msg/NovatelXYZ.idl
// generated code does not contain a copyright notice

#ifndef NOVATEL_GPS_MSGS__MSG__DETAIL__NOVATEL_XYZ__STRUCT_H_
#define NOVATEL_GPS_MSGS__MSG__DETAIL__NOVATEL_XYZ__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'novatel_msg_header'
#include "novatel_gps_msgs/msg/detail/novatel_message_header__struct.h"
// Member 'solution_status'
// Member 'position_type'
// Member 'velocity_solution_status'
// Member 'velocity_type'
// Member 'base_station_id'
#include "rosidl_runtime_c/string.h"
// Member 'extended_solution_status'
#include "novatel_gps_msgs/msg/detail/novatel_extended_solution_status__struct.h"
// Member 'signal_mask'
#include "novatel_gps_msgs/msg/detail/novatel_signal_mask__struct.h"

/// Struct defined in msg/NovatelXYZ in the package novatel_gps_msgs.
/**
  * Parsed Best Position in the WGS-84 ECEF frame from Novatel receiver
 */
typedef struct novatel_gps_msgs__msg__NovatelXYZ
{
  std_msgs__msg__Header header;
  novatel_gps_msgs__msg__NovatelMessageHeader novatel_msg_header;
  /// Position Data (m)
  rosidl_runtime_c__String solution_status;
  rosidl_runtime_c__String position_type;
  double x;
  double y;
  double z;
  /// Position Standard Deviation (m)
  float x_sigma;
  float y_sigma;
  float z_sigma;
  /// Velocity Data
  rosidl_runtime_c__String velocity_solution_status;
  rosidl_runtime_c__String velocity_type;
  double x_vel;
  double y_vel;
  double z_vel;
  /// Velocity Standard Deviation (m/s)
  float x_vel_sigma;
  float y_vel_sigma;
  float z_vel_sigma;
  rosidl_runtime_c__String base_station_id;
  float velocity_latency;
  /// Data Ages (sec)
  float diff_age;
  float solution_age;
  /// Satellite Usage
  uint8_t num_satellites_tracked;
  uint8_t num_satellites_used_in_solution;
  uint8_t num_gps_and_glonass_l1_used_in_solution;
  uint8_t num_gps_and_glonass_l1_and_l2_used_in_solution;
  /// Extended Solution Status
  novatel_gps_msgs__msg__NovatelExtendedSolutionStatus extended_solution_status;
  /// Signal Masks
  novatel_gps_msgs__msg__NovatelSignalMask signal_mask;
} novatel_gps_msgs__msg__NovatelXYZ;

// Struct for a sequence of novatel_gps_msgs__msg__NovatelXYZ.
typedef struct novatel_gps_msgs__msg__NovatelXYZ__Sequence
{
  novatel_gps_msgs__msg__NovatelXYZ * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} novatel_gps_msgs__msg__NovatelXYZ__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // NOVATEL_GPS_MSGS__MSG__DETAIL__NOVATEL_XYZ__STRUCT_H_
